<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: Entity Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classEntity-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Entity Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Abstract class representing GameObjects that have weapon and health.  
 <a href="classEntity.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="Entity_8h_source.html">Entity.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Entity:</div>
<div class="dyncontent">
<div class="center"><img src="classEntity__inherit__graph.png" border="0" usemap="#Entity_inherit__map" alt="Inheritance graph"/></div>
<map name="Entity_inherit__map" id="Entity_inherit__map">
<area shape="rect" title="Abstract class representing GameObjects that have weapon and health." alt="" coords="195,155,255,181"/>
<area shape="rect" href="classEnemy.html" title="Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death." alt="" coords="147,229,214,256"/>
<area shape="rect" href="classPlayer.html" title="Represent player, takes user input." alt="" coords="239,229,301,256"/>
<area shape="rect" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties." alt="" coords="173,80,276,107"/>
<area shape="rect" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce..." alt="" coords="193,5,257,32"/>
<area shape="rect" href="classBomber.html" title="Basic enemy with rocker launcher." alt="" coords="5,304,79,331"/>
<area shape="rect" href="classCruiser.html" title="High health high fire rate enemy, cannot move while firing has cooldown on fire." alt="" coords="103,304,171,331"/>
<area shape="rect" href="classDrone.html" title="Fast low health enemy, bounces off borders." alt="" coords="195,304,257,331"/>
<area shape="rect" href="classFighter.html" title="Basic enemy with machinegun." alt="" coords="281,304,347,331"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for Entity:</div>
<div class="dyncontent">
<div class="center"><img src="classEntity__coll__graph.png" border="0" usemap="#Entity_coll__map" alt="Collaboration graph"/></div>
<map name="Entity_coll__map" id="Entity_coll__map">
<area shape="rect" title="Abstract class representing GameObjects that have weapon and health." alt="" coords="83,171,143,197"/>
<area shape="rect" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties." alt="" coords="5,81,108,108"/>
<area shape="rect" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce..." alt="" coords="25,5,89,32"/>
<area shape="rect" href="classWeapon.html" title="Factory styled class for creating projectiles." alt="" coords="133,81,207,108"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:adf6d3f7cb1b2ba029b6b048a395cc8ae"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEntity.html#adf6d3f7cb1b2ba029b6b048a395cc8ae">~Entity</a> ()</td></tr>
<tr class="memdesc:adf6d3f7cb1b2ba029b6b048a395cc8ae"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy the <a class="el" href="classEntity.html" title="Abstract class representing GameObjects that have weapon and health.">Entity</a> object and deletes allocated weapon.  <a href="classEntity.html#adf6d3f7cb1b2ba029b6b048a395cc8ae">More...</a><br /></td></tr>
<tr class="separator:adf6d3f7cb1b2ba029b6b048a395cc8ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a990ba22de82974bcfad77f68cb74ea7e"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEntity.html#a990ba22de82974bcfad77f68cb74ea7e">Damage</a> (const int &amp;dmg)=0</td></tr>
<tr class="memdesc:a990ba22de82974bcfad77f68cb74ea7e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deals damage to self.  <a href="classEntity.html#a990ba22de82974bcfad77f68cb74ea7e">More...</a><br /></td></tr>
<tr class="separator:a990ba22de82974bcfad77f68cb74ea7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a665dc0ca1dc7018e36645156848d9397"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEntity.html#a665dc0ca1dc7018e36645156848d9397">SetHealth</a> (const int &amp;health)</td></tr>
<tr class="separator:a665dc0ca1dc7018e36645156848d9397"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1d1d591b332c37c5fab7d8ce60acfc0"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEntity.html#ae1d1d591b332c37c5fab7d8ce60acfc0">GetHealth</a> ()</td></tr>
<tr class="separator:ae1d1d591b332c37c5fab7d8ce60acfc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classGameObject"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classGameObject')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classGameObject.html">GameObject</a></td></tr>
<tr class="memitem:a0348e3ee2e83d56eafca7a3547f432c4 inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a0348e3ee2e83d56eafca7a3547f432c4">GameObject</a> ()</td></tr>
<tr class="memdesc:a0348e3ee2e83d56eafca7a3547f432c4 inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> and initializes internal variables.  <a href="classGameObject.html#a0348e3ee2e83d56eafca7a3547f432c4">More...</a><br /></td></tr>
<tr class="separator:a0348e3ee2e83d56eafca7a3547f432c4 inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a224d4f6d9dd75c8a6f9d022eaf586fd9 inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a224d4f6d9dd75c8a6f9d022eaf586fd9">~GameObject</a> ()</td></tr>
<tr class="memdesc:a224d4f6d9dd75c8a6f9d022eaf586fd9 inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor that ensures correct memory handling in derived classes.  <a href="classGameObject.html#a224d4f6d9dd75c8a6f9d022eaf586fd9">More...</a><br /></td></tr>
<tr class="separator:a224d4f6d9dd75c8a6f9d022eaf586fd9 inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd237fc51b336232cd5d97ca0a3266ec inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#afd237fc51b336232cd5d97ca0a3266ec">SetBoundBox</a> (int Width, int Height)</td></tr>
<tr class="memdesc:afd237fc51b336232cd5d97ca0a3266ec inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the bound box for collision handling.  <a href="classGameObject.html#afd237fc51b336232cd5d97ca0a3266ec">More...</a><br /></td></tr>
<tr class="separator:afd237fc51b336232cd5d97ca0a3266ec inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe84ab4b266362535372065ed0aacdfb inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#afe84ab4b266362535372065ed0aacdfb">GetBoundWidth</a> ()</td></tr>
<tr class="separator:afe84ab4b266362535372065ed0aacdfb inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbf0266f9230693a470181d4ee9ef9e8 inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#acbf0266f9230693a470181d4ee9ef9e8">GetBoundHeight</a> ()</td></tr>
<tr class="separator:acbf0266f9230693a470181d4ee9ef9e8 inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a14a2649fb1de4e3e705fb54df2df8f9b inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a14a2649fb1de4e3e705fb54df2df8f9b">SetMovementVector</a> (int vx, int vy)</td></tr>
<tr class="memdesc:a14a2649fb1de4e3e705fb54df2df8f9b inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a movement vector.  <a href="classGameObject.html#a14a2649fb1de4e3e705fb54df2df8f9b">More...</a><br /></td></tr>
<tr class="separator:a14a2649fb1de4e3e705fb54df2df8f9b inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a24428667f904a6445594d884476c67ac inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a24428667f904a6445594d884476c67ac">GetMoveDirHorizontal</a> ()</td></tr>
<tr class="separator:a24428667f904a6445594d884476c67ac inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a68ce660066e5dbc9c1ac9be4fabc558f inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a68ce660066e5dbc9c1ac9be4fabc558f">ObjectMove</a> ()</td></tr>
<tr class="memdesc:a68ce660066e5dbc9c1ac9be4fabc558f inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Moves <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> in direction of a movement vector.  <a href="classGameObject.html#a68ce660066e5dbc9c1ac9be4fabc558f">More...</a><br /></td></tr>
<tr class="separator:a68ce660066e5dbc9c1ac9be4fabc558f inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8133e4ab74ef92b50c14c18382b2397e inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a8133e4ab74ef92b50c14c18382b2397e">Intersects</a> (<a class="el" href="classGameObject.html">GameObject</a> *obj)</td></tr>
<tr class="memdesc:a8133e4ab74ef92b50c14c18382b2397e inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Whenever <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> intersects with obj it resolves collision with use of double dispatch visitor pattern represented by class <a class="el" href="classCollisionVisitor.html" title="Abstract class of double dispatch visitor design patter.">CollisionVisitor</a>.  <a href="classGameObject.html#a8133e4ab74ef92b50c14c18382b2397e">More...</a><br /></td></tr>
<tr class="separator:a8133e4ab74ef92b50c14c18382b2397e inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af71762b88087efbed642c0a728b81792 inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#af71762b88087efbed642c0a728b81792">Visit</a> (<a class="el" href="classCollisionVisitor.html">CollisionVisitor</a> *visitor)=0</td></tr>
<tr class="memdesc:af71762b88087efbed642c0a728b81792 inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pure virtual function for accepting visitor.  <a href="classGameObject.html#af71762b88087efbed642c0a728b81792">More...</a><br /></td></tr>
<tr class="separator:af71762b88087efbed642c0a728b81792 inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abfb8111c32e0c20d2f29d668730c101e inherit pub_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#abfb8111c32e0c20d2f29d668730c101e">CollideWith</a> (<a class="el" href="classGameObject.html">GameObject</a> *collisionObject)=0</td></tr>
<tr class="memdesc:abfb8111c32e0c20d2f29d668730c101e inherit pub_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates Visitor object and passes collisionObject parameter.  <a href="classGameObject.html#abfb8111c32e0c20d2f29d668730c101e">More...</a><br /></td></tr>
<tr class="separator:abfb8111c32e0c20d2f29d668730c101e inherit pub_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classObject"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classObject')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classObject.html">Object</a></td></tr>
<tr class="memitem:a40860402e64d8008fb42329df7097cdb inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a40860402e64d8008fb42329df7097cdb">Object</a> ()</td></tr>
<tr class="memdesc:a40860402e64d8008fb42329df7097cdb inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Construct a new <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a> and initializes internal variables.  <a href="classObject.html#a40860402e64d8008fb42329df7097cdb">More...</a><br /></td></tr>
<tr class="separator:a40860402e64d8008fb42329df7097cdb inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad644b8a35c64ade4e15b3e33a2a5d77f inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#ad644b8a35c64ade4e15b3e33a2a5d77f">GetX</a> () const</td></tr>
<tr class="separator:ad644b8a35c64ade4e15b3e33a2a5d77f inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65d30f9f3b22ed328cb24482ed4ba896 inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a65d30f9f3b22ed328cb24482ed4ba896">GetY</a> () const</td></tr>
<tr class="separator:a65d30f9f3b22ed328cb24482ed4ba896 inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab04c46e902c454a25751f900948d6d5e inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#ab04c46e902c454a25751f900948d6d5e">ForcedRender</a> ()</td></tr>
<tr class="memdesc:ab04c46e902c454a25751f900948d6d5e inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Forces <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a> to render even if position didnt changed.  <a href="classObject.html#ab04c46e902c454a25751f900948d6d5e">More...</a><br /></td></tr>
<tr class="separator:ab04c46e902c454a25751f900948d6d5e inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2199afbf2f52ff746c4c871e434ff20f inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a2199afbf2f52ff746c4c871e434ff20f">Render</a> ()</td></tr>
<tr class="memdesc:a2199afbf2f52ff746c4c871e434ff20f inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Displays <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a> to ncurses stdscr.  <a href="classObject.html#a2199afbf2f52ff746c4c871e434ff20f">More...</a><br /></td></tr>
<tr class="separator:a2199afbf2f52ff746c4c871e434ff20f inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b25442efcce1e5768e3790b36accd1a inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a5b25442efcce1e5768e3790b36accd1a">Clear</a> ()</td></tr>
<tr class="memdesc:a5b25442efcce1e5768e3790b36accd1a inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears sprite that is being displayed to stdscr.  <a href="classObject.html#a5b25442efcce1e5768e3790b36accd1a">More...</a><br /></td></tr>
<tr class="separator:a5b25442efcce1e5768e3790b36accd1a inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cac457fe1568b09a7f510654245972e inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a6cac457fe1568b09a7f510654245972e">SetSprite</a> (const std::string &amp;spr)</td></tr>
<tr class="memdesc:a6cac457fe1568b09a7f510654245972e inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets sprite for later rendering of <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a>.  <a href="classObject.html#a6cac457fe1568b09a7f510654245972e">More...</a><br /></td></tr>
<tr class="separator:a6cac457fe1568b09a7f510654245972e inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a209e2a1b3e3a30a11d1d8595a0147ffb inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a209e2a1b3e3a30a11d1d8595a0147ffb">SetXY</a> (int x, int y)</td></tr>
<tr class="memdesc:a209e2a1b3e3a30a11d1d8595a0147ffb inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets position of <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a>.  <a href="classObject.html#a209e2a1b3e3a30a11d1d8595a0147ffb">More...</a><br /></td></tr>
<tr class="separator:a209e2a1b3e3a30a11d1d8595a0147ffb inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ee5c17a09981cbd7c469370e210b4ff inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a5ee5c17a09981cbd7c469370e210b4ff">Update</a> ()=0</td></tr>
<tr class="memdesc:a5ee5c17a09981cbd7c469370e210b4ff inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pure virtual Update function that is used in <a class="el" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...">GameScene</a>'s game loop.  <a href="classObject.html#a5ee5c17a09981cbd7c469370e210b4ff">More...</a><br /></td></tr>
<tr class="separator:a5ee5c17a09981cbd7c469370e210b4ff inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc113651aab71178e254d7d7f3b1e53b inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#adc113651aab71178e254d7d7f3b1e53b">Destroy</a> ()</td></tr>
<tr class="memdesc:adc113651aab71178e254d7d7f3b1e53b inherit pub_methods_classObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Marks <a class="el" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce...">Object</a> for destruction and garbage collection by <a class="el" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...">GameScene</a>.  <a href="classObject.html#adc113651aab71178e254d7d7f3b1e53b">More...</a><br /></td></tr>
<tr class="separator:adc113651aab71178e254d7d7f3b1e53b inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae0e2dd4a28a6327bad26b43e8101e1d9 inherit pub_methods_classObject"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#ae0e2dd4a28a6327bad26b43e8101e1d9">isMarked</a> () const</td></tr>
<tr class="separator:ae0e2dd4a28a6327bad26b43e8101e1d9 inherit pub_methods_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a91cd0f86409513098d548228466eb6d7"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEntity.html#a91cd0f86409513098d548228466eb6d7">SetupStats</a> ()=0</td></tr>
<tr class="memdesc:a91cd0f86409513098d548228466eb6d7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pure virtual function for setring up variables.  <a href="classEntity.html#a91cd0f86409513098d548228466eb6d7">More...</a><br /></td></tr>
<tr class="separator:a91cd0f86409513098d548228466eb6d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab04e6b564dfedd4641e8df53970e1fbf"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEntity.html#ab04e6b564dfedd4641e8df53970e1fbf">InitWeapon</a> ()=0</td></tr>
<tr class="memdesc:ab04e6b564dfedd4641e8df53970e1fbf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pure virtual function for initializing weapon.  <a href="classEntity.html#ab04e6b564dfedd4641e8df53970e1fbf">More...</a><br /></td></tr>
<tr class="separator:ab04e6b564dfedd4641e8df53970e1fbf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classGameObject"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classGameObject')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classGameObject.html">GameObject</a></td></tr>
<tr class="memitem:a209b156ef8eec011eba664f3987d4ff7 inherit pro_methods_classGameObject"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a209b156ef8eec011eba664f3987d4ff7">OnBorderCollision</a> ()</td></tr>
<tr class="memdesc:a209b156ef8eec011eba664f3987d4ff7 inherit pro_methods_classGameObject"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroys <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> if it collides with top and bottom border.  <a href="classGameObject.html#a209b156ef8eec011eba664f3987d4ff7">More...</a><br /></td></tr>
<tr class="separator:a209b156ef8eec011eba664f3987d4ff7 inherit pro_methods_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:aa4cb7571a862fe9c5170dce0845b8d0b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEntity.html#aa4cb7571a862fe9c5170dce0845b8d0b">m_Health</a></td></tr>
<tr class="separator:aa4cb7571a862fe9c5170dce0845b8d0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a636d319a245a619c34290aafe061db7f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classWeapon.html">Weapon</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEntity.html#a636d319a245a619c34290aafe061db7f">m_Weapon</a></td></tr>
<tr class="separator:a636d319a245a619c34290aafe061db7f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classGameObject"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classGameObject')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classGameObject.html">GameObject</a></td></tr>
<tr class="memitem:a2831bbdeef51b7dec1c886a3792a5021 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a2831bbdeef51b7dec1c886a3792a5021">m_BoundBoxWidth</a></td></tr>
<tr class="separator:a2831bbdeef51b7dec1c886a3792a5021 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a478d95fa66433fb8b63e1de62df32a05 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a478d95fa66433fb8b63e1de62df32a05">m_BoundBoxHeight</a></td></tr>
<tr class="separator:a478d95fa66433fb8b63e1de62df32a05 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a18cf227e1f9b1246ad72e555060f5602 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a18cf227e1f9b1246ad72e555060f5602">m_MovementSpeed</a></td></tr>
<tr class="separator:a18cf227e1f9b1246ad72e555060f5602 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a06399d2e83dbed0bbcdd23a45708e743 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">std::chrono::time_point&lt; std::chrono::system_clock &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a06399d2e83dbed0bbcdd23a45708e743">m_LastMovementAt</a></td></tr>
<tr class="separator:a06399d2e83dbed0bbcdd23a45708e743 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cfd998f5afb701fdd721c5e5a00897b inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#a4cfd998f5afb701fdd721c5e5a00897b">m_VectX</a></td></tr>
<tr class="separator:a4cfd998f5afb701fdd721c5e5a00897b inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aebfa0ceffe82ed29b0fd2ef37050e992 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#aebfa0ceffe82ed29b0fd2ef37050e992">m_VectY</a></td></tr>
<tr class="separator:aebfa0ceffe82ed29b0fd2ef37050e992 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc176e5a277e67b70ba1d2292ade28c7 inherit pro_attribs_classGameObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameObject.html#abc176e5a277e67b70ba1d2292ade28c7">m_DiagonalCounter</a></td></tr>
<tr class="separator:abc176e5a277e67b70ba1d2292ade28c7 inherit pro_attribs_classGameObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classObject"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classObject')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classObject.html">Object</a></td></tr>
<tr class="memitem:a20bdbcf7662f94b783461df61f1dead2 inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a20bdbcf7662f94b783461df61f1dead2">m_MarkForDestruction</a></td></tr>
<tr class="separator:a20bdbcf7662f94b783461df61f1dead2 inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa080149410482bbf134f663f0eec478a inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#aa080149410482bbf134f663f0eec478a">m_PositionChanged</a></td></tr>
<tr class="separator:aa080149410482bbf134f663f0eec478a inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a995c8304abf2e3fd8fb29b59ab1048cc inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a995c8304abf2e3fd8fb29b59ab1048cc">m_X</a></td></tr>
<tr class="separator:a995c8304abf2e3fd8fb29b59ab1048cc inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e33bf8f94303c821e0036975f1f9e44 inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#a1e33bf8f94303c821e0036975f1f9e44">m_Y</a></td></tr>
<tr class="separator:a1e33bf8f94303c821e0036975f1f9e44 inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab3f832ee25ca13bad87645c44c7019e3 inherit pro_attribs_classObject"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classObject.html#ab3f832ee25ca13bad87645c44c7019e3">m_Sprite</a></td></tr>
<tr class="separator:ab3f832ee25ca13bad87645c44c7019e3 inherit pro_attribs_classObject"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Abstract class representing GameObjects that have weapon and health. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="adf6d3f7cb1b2ba029b6b048a395cc8ae"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adf6d3f7cb1b2ba029b6b048a395cc8ae">&#9670;&nbsp;</a></span>~Entity()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Entity::~Entity </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Destroy the <a class="el" href="classEntity.html" title="Abstract class representing GameObjects that have weapon and health.">Entity</a> object and deletes allocated weapon. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a990ba22de82974bcfad77f68cb74ea7e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a990ba22de82974bcfad77f68cb74ea7e">&#9670;&nbsp;</a></span>Damage()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Entity::Damage </td>
          <td>(</td>
          <td class="paramtype">const int &amp;&#160;</td>
          <td class="paramname"><em>dmg</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Deals damage to self. </p>

<p>Implemented in <a class="el" href="classEnemy.html#a42ec023b4093dcc4d68a7c9f9137d5a5">Enemy</a>, and <a class="el" href="classPlayer.html#ab875e8cc8856544fdff9759cd5576266">Player</a>.</p>

</div>
</div>
<a id="ae1d1d591b332c37c5fab7d8ce60acfc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae1d1d591b332c37c5fab7d8ce60acfc0">&#9670;&nbsp;</a></span>GetHealth()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Entity::GetHealth </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ab04e6b564dfedd4641e8df53970e1fbf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab04e6b564dfedd4641e8df53970e1fbf">&#9670;&nbsp;</a></span>InitWeapon()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Entity::InitWeapon </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Pure virtual function for initializing weapon. </p>

<p>Implemented in <a class="el" href="classCruiser.html#ae47dfbab1b9f7837d138f617a43593c1">Cruiser</a>, <a class="el" href="classDrone.html#af9fc8b290a80200d599b85b82f27db6b">Drone</a>, <a class="el" href="classBomber.html#af331f516205a9310d07cad2869391ff1">Bomber</a>, <a class="el" href="classPlayer.html#aec557c30fd3a978e4a44d1aad9e033fc">Player</a>, and <a class="el" href="classFighter.html#a0ecbca6d3e98a60aa971c596375846c5">Fighter</a>.</p>

</div>
</div>
<a id="a665dc0ca1dc7018e36645156848d9397"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a665dc0ca1dc7018e36645156848d9397">&#9670;&nbsp;</a></span>SetHealth()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Entity::SetHealth </td>
          <td>(</td>
          <td class="paramtype">const int &amp;&#160;</td>
          <td class="paramname"><em>health</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a91cd0f86409513098d548228466eb6d7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a91cd0f86409513098d548228466eb6d7">&#9670;&nbsp;</a></span>SetupStats()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Entity::SetupStats </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Pure virtual function for setring up variables. </p>

<p>Implemented in <a class="el" href="classCruiser.html#a1bdf01c4ccf5cb4305710274cfe5ae65">Cruiser</a>, <a class="el" href="classDrone.html#afdee1b510410d6512bd9898cfbbf2faf">Drone</a>, <a class="el" href="classBomber.html#a978b4fce46f9b875fc412cb20bc2c001">Bomber</a>, <a class="el" href="classPlayer.html#a4c3cae84a7c20d37295b4dacca62c553">Player</a>, and <a class="el" href="classFighter.html#a111291f871d86c69177b66b832078899">Fighter</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="aa4cb7571a862fe9c5170dce0845b8d0b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa4cb7571a862fe9c5170dce0845b8d0b">&#9670;&nbsp;</a></span>m_Health</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int Entity::m_Health</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a636d319a245a619c34290aafe061db7f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a636d319a245a619c34290aafe061db7f">&#9670;&nbsp;</a></span>m_Weapon</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classWeapon.html">Weapon</a>* Entity::m_Weapon</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="Entity_8h_source.html">Entity.h</a></li>
<li>src/<a class="el" href="Entity_8cpp.html">Entity.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
